mostly new music stuff
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 export LESS=RXij12
228 export SYSTEMD_LESS=$LESS
229
230 export NNN_COLORS=2136
231
232 export SL_FILES_DIR=/b/ds/sl/.iank
233 export SL_INFO_DIR=/p/sshinfo
234
235
236 # * include files
237
238 if [[ -s $bashrc_dir/path-add-function ]]; then
239 source $bashrc_dir/path-add-function
240 if [[ $SSH_CLIENT ]]; then
241 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
242 export EMACSDIR=/home/iank/.iank/e/e
243 fi
244 path-add $bashrc_dir
245 fi
246 fi
247
248 # if someone exported $SOE (stop on error), catch errors.
249 #
250 # Note, on debian this results in the following warning when in ssh,
251 # hich I haven't figured out how to fix. It doesn't happen if we source
252 # after the shell has started
253 #
254 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
255 # bash: warning: cannot start debugger; debugging mode disabled
256 if [[ $SOE ]]; then
257 if [[ -e /a/bin/errhandle/err ]]; then
258 source /a/bin/errhandle/err
259 fi
260 fi
261
262
263
264
265 mysrc() {
266 local path dir file
267 path=$1
268 dir=${path%/*}
269 file=${path##*/}
270 if [[ -s $path ]]; then
271 source $path
272 elif [[ -s $bashrc_dir/$file ]]; then
273 source $bashrc_dir/$file
274 fi
275 }
276
277
278 mysrc /a/bin/small-misc-bash/ll-function
279 mysrc /a/bin/distro-functions/src/package-manager-abstractions
280
281
282 # * functions
283
284 ### begin FSF section ###
285
286 # Comments before functions are meant to be good useful
287 # documentation. If they fail at that, please improve them or send Ian a
288 # note.
289
290 ## copy bash completion
291 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
292 #
293 # It copies how the bash completion works from one command to other
294 # commands.
295 ccomp() {
296 local c src
297 src=$1
298 shift
299 if ! c=$(complete -p $src 2>/dev/null); then
300 _completion_loader $src &>/dev/null ||:
301 c=$(complete -p $src 2>/dev/null) || return 0
302 fi
303 # remove $src( .*|$)
304 c=${c% $src}
305 c=${c%% $src *}
306 eval $c $*
307 }
308
309 ## directory history tracking and navigation.
310 #
311 # cd becomes a function, also aliased to c. b to go back, f to go
312 # forward, cl to list recent directories and choose one.
313 #
314 # The finer details you may want to skip:
315 #
316 # We also define bl to print the list of back and forward directories.
317 #
318 # We keep 2 stacks, forward and back. Unlike with a web browser, the
319 # forward stack is not erased when going somewhere new.
320 #
321 # Recent directories are stored in ~/.cdirs.
322 #
323 declare -a _dir_forward _dir_back
324 c() {
325 # normally, the top of _dir_back is our current dir. if it isn't,
326 # put it on there, except we don't want to do that when we
327 # just launched a shell
328 if [[ $OLDPWD ]]; then
329 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
330 _dir_back+=("$PWD")
331 fi
332 fi
333 command cd "$@"
334 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
335 _dir_back+=("$PWD")
336 fi
337 echo "$PWD" >> ~/.cdirs
338 }
339 ccomp cd c
340
341 # back
342 b() {
343 local top_back
344 if (( ${#_dir_back[@]} == 0 )); then
345 echo "nothing left to go back to" >&2
346 return 0
347 fi
348 top_back="${_dir_back[-1]}"
349
350 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
351 echo "already on last back entry" >&2
352 return 0
353 fi
354
355
356 if [[ $top_back == "$PWD" ]]; then
357 # add to dirf if not already there
358 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
359 _dir_forward+=("$top_back")
360 fi
361 unset "_dir_back[-1]"
362 command cd "${_dir_back[-1]}"
363 else
364 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
365 _dir_forward+=("$PWD")
366 fi
367 command cd "$top_back"
368 fi
369
370 # Interesting feature, not sure I want it.
371 # give us a peek at what is next in the list
372 # if (( ${#_dir_back[@]} >= 2 )); then
373 # printf "%s\n" "${_dir_back[-2]}"
374 # fi
375 #
376
377 # c/b/f Implementation notes:
378 #
379 # The top of the back is $PWD
380 # as long as the last directory change was due to c,b,or cl.
381 #
382 # Example of stack changes:
383 #
384 # a b c (d)
385 ## back
386 # a b (c)
387 # d
388 #back
389 #a (b)
390 #d c
391 #back
392 #(a)
393 #d c b
394 #forward
395 #a (b)
396 #d c
397 #
398 # a b c
399 ## back
400 # a b
401 # (c)
402 ## forward
403
404 }
405 # forward
406 f() {
407 local top_forward
408 if (( ${#_dir_forward[@]} == 0 )); then
409 echo "no forward dir left" >&2
410 return 0
411 fi
412 top_forward="${_dir_forward[-1]}"
413 unset "_dir_forward[-1]"
414 c "$top_forward"
415
416 # give us a peek at what is next in the list
417 # if (( ${#_dir_forward[@]} )); then
418 # printf "%s\n" "${_dir_forward[-1]}"
419 # fi
420 }
421 # cd list
422 cl() {
423 local i line input start
424 local -A buttondirs alines
425 local -a buttons dirs lines
426 buttons=( {a..z} {2..9} )
427 if [[ ! -s ~/.cdirs ]]; then
428 echo nothing in ~/.cdirs
429 return 0
430 fi
431
432 i=0
433
434 mapfile -t lines <~/.cdirs
435 start=$(( ${#lines[@]} - 1 ))
436
437 # we have ~33 buttons as of this writing, so lets
438 # prune down the history every once in a while.
439 if (( start > 500 )); then
440 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
441 fi
442
443 for (( j=$start; j >= 0; j-- )); do
444 line="${lines[$j]}"
445 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
446 continue
447 fi
448 alines[$line]=t
449 buttondirs[${buttons[i]}]="$line"
450 printf "%s %s\n" ${buttons[i]} "$line"
451 if (( i == ${#buttons[@]} - 1 )); then
452 break
453 fi
454 i=$(( i + 1 ))
455 done
456
457 if (( i == 0 )); then
458 echo "no dirs in ~/.cdirs"
459 return 0
460 fi
461 read -r -N 1 input
462 if [[ $input != $'\n' ]]; then
463 c "${buttondirs[$input]}"
464 fi
465 }
466 # back list
467 bl() {
468 local start i j max
469 max=10
470 start=$(( ${#_dir_back[@]} - 1 ))
471
472 # cleanup possible repeating of pwd
473 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
474 start=$(( start - 1 ))
475 fi
476 j=1
477 if (( start >= 0 )); then
478 for (( i=$start; i >= 0 ; i-- )); do
479 printf "%s %s\n" $j ${_dir_back[i]}
480 j=$(( j + 1 ))
481 if (( j >= max )); then
482 break
483 fi
484 done
485 fi
486
487 max=10
488 start=$(( ${#_dir_forward[@]} - 1 ))
489
490 # cleanup possible repeating of pwd
491 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
492 start=$(( start - 1 ))
493 fi
494 if (( start < 0 )); then
495 return 0
496 fi
497 echo --
498 j=1
499 for (( i=$start; i >= 0 ; i-- )); do
500 printf "%s %s\n" $j ${_dir_forward[i]}
501 j=$(( j + 1 ))
502 if (( j >= max )); then
503 break
504 fi
505 done
506 }
507
508 # pee do. run args as a command with output copied to syslog.
509 #
510 # Usage: pd [-t TAG] COMMAND...
511 #
512 # -t TAG Override the tag in the syslog. The default is COMMAND with
513 # any path part is removed, eg. for /bin/cat the tag is cat.
514 #
515 # You can view the log via "journalctl -t TAG"
516 pd() {
517 local tag ret
518 ret=0
519 tag=${1##*/}
520 case $1 in
521 -t) tag="$2"; shift 2 ;;
522 esac
523 echo "PWD=$PWD command: $*" | logger -t $tag
524 "$@" |& pee cat "logger -t $tag" || ret=$?
525 echo "exited with status=$ret" | pee cat "logger -t $tag"
526 # this avoids any err-catch
527 (( $ret == 0 )) || return $ret
528 }
529 ccomp time pd
530
531 # jdo = journal do. Run command as transient systemd service, tailing
532 # its output in the journal until it completes.
533 #
534 # Usage: jdo COMMAND...
535 #
536 # Compared to pd: commands recognize this is a non-interactive shell.
537 # The service is unaffected if our ssh connection dies, no need to run
538 # in screen or tmux.
539 #
540 # Note: The last few lines of any existing entries for a unit by that
541 # name will be output first, and there will be a few second delay at the
542 # start of the command, and a second or so at the end.
543 #
544 # Note: Functions and aliases obviously won't work, we resolve the
545 # command to a file.
546 #
547 # Note: requires running as root.
548 jdo() {
549 local cmd cmd_name jr_pid ret
550 ret=0
551 cmd="$1"
552 shift
553 if [[ $EUID != 0 ]]; then
554 echo "jdo: error: rerun as root"
555 return 1
556 fi
557 cmd_name=${cmd##*/}
558 if [[ $cmd != /* ]]; then
559 cmd=$(type -P "$cmd")
560 fi
561 # -q = quiet
562 journalctl -qn2 -f -u "$cmd_name" &
563 # Trial and error of time needed to avoid missing initial lines.
564 # .5 was not reliable. 1 was not reliable. 2 was not reliable
565 sleep 4
566 jr_pid=$!
567 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
568 # The sleep lets the journal output its last line
569 # before the prompt comes up.
570 sleep .5
571 kill $jr_pid &>/dev/null ||:
572 unset jr_pid
573 fg &>/dev/null ||:
574 # this avoids any err-catch
575 (( $ret == 0 )) || return $ret
576 }
577 ccomp time jdo
578 #### end fsf section
579
580
581 ..() { c ..; }
582 ...() { c ../..; }
583 ....() { c ../../..; }
584 .....() { c ../../../..; }
585 ......() { c ../../../../..; }
586
587 chere() {
588 local f path
589 for f; do
590 path=$(readlink -e "$f")
591 echo "cat >$path <<'EOF'"
592 cat "$f"
593 echo EOF
594 done
595 }
596
597
598 # file cut copy and paste, like the text buffers :)
599 # I havnt tested these.
600 _fbufferinit() { # internal use
601 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
602 rm -rf "${my_f_tempdir:?}"/*
603 }
604 fcp() { # file cp
605 _fbufferinit
606 cp "$@" "$my_f_tempdir"/
607 }
608 fct() { # file cut
609 _fbufferinit
610 mv "$@" "$my_f_tempdir"/
611 }
612 fpst() { # file paste
613 [[ $2 ]] && { echo too many arguments; return 1; }
614 target=${1:-.}
615 cp "$my_f_tempdir"/* "$target"
616 }
617
618 _khfix_common() {
619 local host ip port file key
620 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
621 file=$(readlink -f ~/.ssh/known_hosts)
622 if [[ ! $ip ]]; then
623 echo "khfix: ssh failed"
624 return 1
625 fi
626 if [[ $port != 22 ]]; then
627 ip_entry="[$ip]:$port"
628 host_entry="[$host]:$port"
629 else
630 ip_entry=$ip
631 host_entry=$host
632 fi
633 tmpfile=$(mktemp)
634 if [[ $host != $ip ]]; then
635 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
636 if [[ $key ]]; then
637 grep -Fv "$key" "$file" | sponge "$file"
638 fi
639 fi
640 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
641 if [[ $key ]]; then
642 grep -Fv "$key" "$file" | sponge "$file"
643 fi
644 ll ~/.ssh/known_hosts
645 rootsshsync
646 }
647 khfix() { # known hosts fix
648 _khfix_common "$@" || return 1
649 ssh $1 :
650 }
651 khcopy() {
652 _khfix_common "$@"
653 ssh-copy-id $1
654 }
655
656 a() {
657 local x
658 x=$(readlink -nf "${1:-$PWD}")
659 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
660 echo -n "$x" | xclip -selection clipboard
661 echo -n "$x" | xclip
662 }
663
664 # a1 = awk {print $1}
665 for field in {1..20}; do
666 eval a$field"() { awk '{print \$$field}'; }"
667 done
668 # h1 = head -n1
669 for num in {1..9}; do
670 eval h$num"() { head -n$num; }"
671 done
672
673
674 hexipv4() {
675 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
676 }
677
678 vp9() {
679 local f out outdir in
680 outdir=vp9
681 case $1 in
682 --out)
683 outdir=$2
684 shift 2
685 ;;
686 esac
687 m mkdir -p $outdir
688 for f; do
689 out=$PWD/$outdir/$f
690 in=$PWD/$f
691 m cd $(mktemp -d)
692 pwd
693 m ffmpeg -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
694 m ffmpeg -y -threads 0 -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
695 cd -
696 done
697 }
698
699 utcl() { # utc 24 hour time to local hour 24 hour time
700 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
701 }
702
703 bwm() {
704 s bwm-ng -T avg -d
705 }
706
707
708 # for running in a fai rescue. iank specific.
709 kdrescue() {
710 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
711 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
712 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
713 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
714 done
715 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
716 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
717 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
718 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
719 cd /mnt
720 chrbind
721 }
722
723
724
725
726 c4() { c /var/log/exim4; }
727
728 caa() { git commit --amend --no-edit -a; }
729
730 cf() {
731 for f; do
732 hr
733 echo "$f"
734 hr
735 cat "$f"
736 done
737 }
738 caf() {
739 # shellcheck disable=SC2033
740 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
741 -o -name .hg -prune -o -name .editor-backups -prune \
742 -o -name .undo-tree-history -prune \) \
743 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
744
745 }
746 ccomp cat cf caf
747
748 calc() { echo "scale=3; $*" | bc -l; }
749 # no having to type quotes, but also no command history:
750 clc() {
751 local x
752 read -r x
753 echo "scale=3; $x" | bc -l
754 }
755
756 cam() {
757 git commit -am "$*"
758 }
759
760 ccat () { # config cat. see a config without extra lines.
761 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
762 }
763 ccomp grep ccat
764
765 chrbind() {
766 local d
767 # dev/pts needed for pacman signature check
768 for d in dev proc sys dev/pts; do
769 [[ -d $d ]]
770 if ! mountpoint $d &>/dev/null; then
771 m s mount -o bind /$d $d
772 fi
773 done
774 }
775 chumount() {
776 local d
777 # dev/pts needed for pacman signature check
778 for d in dev/pts dev proc sys; do
779 [[ -d $d ]]
780 if mountpoint $d &>/dev/null; then
781 m s umount $d
782 fi
783 done
784 }
785
786
787 _cdiff-prep() {
788 # join options which are continued to multiples lines onto one line
789 local first=true
790 while IFS= read -r line; do
791 # remove leading spaces/tabs. assumes extglob
792 if [[ $line == "[ ]*" ]]; then
793 line="${line##+( )}"
794 fi
795 if $first; then
796 pastline="$line"
797 first=false
798 elif [[ $line == *=* ]]; then
799 echo "$pastline" >> "$2"
800 pastline="$line"
801 else
802 pastline="$pastline $line"
803 fi
804 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
805 echo "$pastline" >> "$2"
806 }
807
808 cdiff() {
809 # diff config files,
810 # setup for format of postfix, eg:
811 # option = stuff[,]
812 # [more stuff]
813 local pastline unified f1 f2
814 unified="$(mktemp)"
815 f1="$(mktemp)"
816 f2="$(mktemp)"
817 _cdiff-prep "$1" "$f1"
818 _cdiff-prep "$2" "$f2"
819 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
820 while IFS= read -r line; do
821 # the default bright red / blue doesnt work in emacs shell
822 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
823 done < "$unified"
824 }
825
826
827 cat-new-files() {
828 local start=$SECONDS
829 local dir="$1"
830 # shellcheck disable=SC2030
831 inotifywait -m "$dir" -e create -e moved_to | \
832 while read -r filedir _ file; do
833 cat "$filedir$file"
834 hr
835 calc $((SECONDS - start)) / 60
836 sleep 5
837 done
838
839 }
840
841 chownme() {
842 s chown -R $USER:$USER "$@"
843 }
844
845 # shellcheck disable=SC2032
846 chown() {
847 # makes it so chown -R symlink affects the symlink and its target.
848 if [[ $1 == -R ]]; then
849 shift
850 command chown -h "$@"
851 command chown -R "$@"
852 else
853 command chown "$@"
854 fi
855 }
856
857 cim() {
858 git commit -m "$*"
859 }
860
861
862 d() { builtin bg "$@"; }
863 ccomp bg d
864
865 # f would be more natural, but i already am using it for something
866 z() { builtin fg "$@"; }
867 ccomp fg z
868
869 dc() {
870 diff --strip-trailing-cr -w "$@" # diff content
871 }
872 ccomp diff dc
873
874 despace() {
875 local x y
876 for x in "$@"; do
877 y="${x// /_}"
878 safe_rename "$x" "$y"
879 done
880 }
881
882 # df progress
883 # usage: dfp MOUNTPOINT [SECOND_INTERVAL]
884 # SECOND_INTERVAL defaults to 90
885 dfp() {
886 # mp = mountpoint
887 local a b mp interval
888 mp=$1
889 interval=${2:-90}
890 if [[ ! $mp ]]; then
891 echo "dfp: error, missing 1st arg" >&2
892 return 1
893 fi
894 while true; do
895 a=$(df --output=used $mp | tail -n1)
896 sleep $interval
897 b=$(df --output=used $mp | tail -n1)
898 printf "used mib: %'d mib/min: %s\n" $(( b /1000 )) $(( (b-a) / (interval * 1000 / 60 ) ))
899 done
900 }
901
902 # get ipv4 ip from HOST. or if it is already a number, return that
903 hostip() {
904 local host="$1"
905 case $host in
906 [0-9:])
907 echo "$host"
908 ;;
909 *)
910 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
911 ;;
912 esac
913 }
914
915 dig() {
916 command dig +nostats +nocmd "$@"
917 }
918 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
919 digsort() {
920 local sec
921 sec=
922 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
923 if [[ $l == [^\;]* ]]; then
924 sec+="$l"$'\n'
925 else
926 if [[ $sec ]]; then
927 printf "%s" "$sec" | sort
928 sec=
929 fi
930 printf "%s\n" "$l"
931 fi
932 done
933 }
934 ccomp dig digsort
935 # compare digs to the 2 servers
936 # usage: digdiff @server1 @server2 DIG_ARGS
937 # note: only the soa master nameserver will respond with
938 # ra "recursive answer" flag. That difference is meaningless afaik.
939 digdiff() {
940 local s1 s2
941 s1=$1
942 shift
943 s2=$1
944 shift
945 digsort $s1 "$@" | tee /tmp/digdiff
946 diff -u /tmp/digdiff <(digsort $s2 "$@")
947 }
948
949 dt() {
950 date "+%A, %B %d, %r" "$@"
951 }
952 dtr() {
953 date -R "$@"
954 }
955 ccomp date dt dtr
956
957 dus() { # du, sorted, default arg of
958 du -sh ${@:-*} | sort -h
959 }
960 ccomp du dus
961
962
963 e() { printf "%s\n" "$*"; }
964
965 # echo args
966 ea() {
967 if (( ! $# )); then
968 echo no args
969 fi
970 for arg; do
971 printf "%qEOL\n" "${arg}"
972 printf "%s" "${arg}" |& hexdump -C
973 done
974 }
975
976 # echo variables. print var including escapes, etc, like xxd for variable
977 ev() {
978 if (( ! $# )); then
979 echo no args
980 fi
981 for arg; do
982 if [[ -v $arg ]]; then
983 printf "%qEOL\n" "${!arg}"
984 printf "%s" "${!arg}" |& hexdump -C
985 else
986 echo arg $arg is unset
987 fi
988 done
989 }
990
991 ediff() {
992 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
993 emacs --eval "(ediff-files \"$1\" \"$2\")"
994 }
995
996 # mail related
997 etail() {
998 ngset
999 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
1000 ngreset
1001 }
1002 etailm() {
1003 tail -F /var/log/exim4/mainlog -n 200 "$@"
1004 }
1005 etail2() {
1006 tail -F /var/log/exim4/mymain -n 200 "$@"
1007 }
1008 ccomp tail etail etail2
1009
1010
1011
1012
1013 # print exim old pids
1014 eoldpids() {
1015 local configtime pid piduptime now daemonpid
1016 printf -v now '%(%s)T' -1
1017 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
1018 if [[ -s /run/exim4/exim.pid ]]; then
1019 daemonpid=$(cat /run/exim4/exim.pid)
1020 fi
1021 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
1022 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
1023 if [[ $pid == $daemonpid ]]; then
1024 continue
1025 fi
1026 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
1027 if (( configtime > now - piduptime )); then
1028 echo $pid
1029 fi
1030 done
1031 }
1032
1033 # exim tail but only watch lines from new pids
1034 etailnew() {
1035 local pid oldpids
1036 for pid in $(eoldpids); do
1037 oldpids+="$pid|"
1038 done
1039 if [[ $oldpids ]]; then
1040 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1041 else
1042 etail
1043 fi
1044 }
1045 # exim watch as old pids go away
1046 ewatchold() {
1047 local configtime pid piduptime now
1048 local -i count
1049 local -a oldpids
1050 count=0
1051 while true; do
1052 oldpids=($(eoldpids))
1053 if (( ! ${#oldpids[@]} )); then
1054 return
1055 fi
1056 # print the date every 20 iterations
1057 if (( ! count % 20 )); then
1058 date
1059 fi
1060 count+=1
1061 ps -f -p "${oldpids[*]}"
1062 sleep 1
1063 done
1064 }
1065
1066 eless() {
1067 less /var/log/exim4/mainlog
1068 }
1069 ccomp less eless
1070 eqcat() {
1071 exiqgrep -ir.\* -o 60 | while read -r i; do
1072 hlm exim -Mvc $i
1073 echo
1074 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1075 done
1076 }
1077 eqrmf() {
1078 # other ways to get the list of message ids:
1079 # exim -bp | awk 'NF == 4 {print $3}'
1080 # # this is slower 160ms, vs 60.
1081 # exipick -i
1082 exiqgrep -ir.\* | xargs exim -Mrm
1083 }
1084
1085 econfdevnew() {
1086 rm -rf /tmp/edev
1087 mkdir -p /tmp/edev/etc
1088 cp -ra /etc/exim4 /tmp/edev/etc
1089 cp -ra /etc/alias* /tmp/edev/etc
1090 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1091 econfdev
1092 }
1093 econfdev() {
1094 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1095 }
1096
1097
1098
1099
1100 fa() {
1101 # find array. make an array of file names found by find into $x
1102 # argument: find arguments
1103 # return: find results in an array $x
1104 while read -rd ''; do
1105 x+=("$REPLY");
1106 done < <(find "$@" -print0);
1107 }
1108
1109 faf() { # find all files. use -L to follow symlinks
1110 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1111 -o -name .hg -prune -o -name .editor-backups -prune \
1112 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1113 }
1114
1115 # full path without resolving symlinks
1116 fp() {
1117 local dir base
1118 base="${1##*/}"
1119 dir="${1%$base}"
1120 printf "%s/%s\n" $(cd $dir; pwd) "$base"
1121 }
1122
1123
1124 # mail related
1125 frozen() {
1126 rm -rf /tmp/frozen
1127 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1128 sudo exim -Mvl $id
1129 echo
1130 sudo exim -Mvh $id
1131 echo
1132 sudo exim -Mvb $id
1133 echo -e '\n\n##############################\n'
1134 done | tee -a /tmp/frozen
1135 }
1136 frozenrm() {
1137 local ids=()
1138 while read -r line; do
1139 printf '%s\n' "$line"
1140 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
1141 done < <(s mailq)
1142 echo "sleeping for 2 in case you change your mind"
1143 sleep 2
1144 sudo exim -Mrm "${ids[@]}"
1145 }
1146
1147 funce() {
1148 # like -e for functions. returns on error.
1149 # at the end of the function, disable with:
1150 # trap ERR
1151 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1152 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1153 trap ERR
1154 return' ERR
1155 }
1156
1157 getdir () {
1158 local help="Usage: getdir [--help] PATH
1159 Output the directory of PATH, or just PATH if it is a directory."
1160 if [[ $1 == --help ]]; then
1161 echo "$help"
1162 return 0
1163 fi
1164 if [[ $# -ne 1 ]]; then
1165 echo "getdir error: expected 1 argument, got $#"
1166 return 1
1167 fi
1168 if [[ -d $1 ]]; then
1169 echo "$1"
1170 else
1171 local dir
1172 dir="$(dirname "$1")"
1173 if [[ -d $dir ]]; then
1174 echo "$dir"
1175 else
1176 echo "getdir error: directory does not exist"
1177 return 1
1178 fi
1179 fi
1180 }
1181
1182 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1183 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1184 local root
1185 root=$(gitroot) || return 1 # function to set gitroot
1186 builtin cd "$root"
1187 git symbolic-ref HEAD refs/heads/$1
1188 rm .git/index
1189 git clean -fdx
1190 }
1191
1192 # shellcheck disable=SC2120
1193 gitroot() {
1194 local help="Usage: gitroot [--help]
1195 Print the full path to the root of the current git repo
1196
1197 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1198 and works in older versions of git which did not have that."
1199 if [[ $1 == --help ]]; then
1200 echo "$help"
1201 return
1202 fi
1203 local p
1204 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1205 [[ $p != /* ]] && p=$PWD
1206 echo "${p%%/.git}"
1207 }
1208
1209 g() {
1210
1211 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1212 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1213
1214 local args gdb=false
1215
1216 if [[ $EMACSDIR ]]; then
1217 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1218 fi
1219
1220 if [[ $DISPLAY ]]; then
1221 args=-n
1222 fi
1223
1224 if (( $# == 0 )); then
1225 args+=" -c"
1226 fi
1227 # duplicate -c, but oh well
1228 if ! pgrep -u $EUID emacsclient; then
1229 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1230 gdb=true
1231 else
1232 args+=" -c"
1233 fi
1234 fi
1235 if [[ $EMACSDIR ]]; then
1236 # Alter the path here, otherwise the nfs mount gets triggered on the
1237 # first path lookup when emacs is not being used.
1238 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1239 else
1240 if $gdb; then
1241 # due to a bug, we cant debug from the start unless we get a new gdb
1242 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1243 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1244 m emacsclient -a "" $args "$@"
1245 sleep 1
1246 cd /a/opt/emacs-$(distro-name)$(distro-num)
1247 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1248 cd -
1249 else
1250 m emacsclient -a "" $args "$@"
1251 fi
1252 fi
1253 }
1254
1255 # force terminal version
1256 gn() {
1257 g -n "$@"
1258 }
1259
1260 gmacs() {
1261 # quit will prompt if the program crashes.
1262 gdb -ex=r -ex=quit --args emacs "$@"; r;
1263 }
1264
1265 gdkill() {
1266 # kill the emacs daemon
1267 pk1 emacs --daemon
1268 }
1269
1270 gr() {
1271 grep -iIP --color=auto "$@" || return $?
1272 }
1273 grr() { # grep recursive
1274 # Don't return 1 on nonmatch because this is meant to be
1275 # interactive, not in a conditional.
1276 if [[ ${#@} == 1 ]]; then
1277 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1278 else
1279 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1280 fi
1281 }
1282 ccomp grep gr grr
1283
1284 rg() { grr "$@"; }
1285 ccomp grep rg
1286
1287 hr() { # horizontal row. used to break up output
1288 printf "$(tput setaf 5 2>/dev/null ||:)█$(tput sgr0 2>/dev/null||:)%.0s" $(eval echo "{1..${COLUMNS:-60}}")
1289 echo
1290 }
1291 # highlight
1292 hl() {
1293 local col input_len=0
1294 for arg; do
1295 input_len=$((input_len + 1 + ${#arg}))
1296 done
1297 col=$((60 - input_len))
1298 printf "\e[1;97;41m%s" "$*"
1299 if (( col > 0 )); then
1300 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1301 fi
1302 echo
1303 }
1304 hlm() { hl "$*"; "$@"; }
1305
1306 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1307
1308
1309 # get latest hub and run it
1310 # main command to use:
1311 # hub pull-request --no-edit
1312 # --no-edit means to use the first commit\'s message as the pull request message.
1313 # If that fails, try doing
1314 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1315 # where branch is usually master. it does the pr against your current branch.
1316 #
1317 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1318 # it\'s at ~/.config/hub
1319 hub() {
1320 local up uptar updir p v
1321 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1322 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1323 re='[[:space:]]'
1324 if [[ ! $up || $up == $re ]]; then
1325 echo "failed to get good update url. got: $up"
1326 fi
1327 uptar=${up##*/}
1328 updir=${uptar%.tgz}
1329 if [[ ! -e /a/opt/$updir ]]; then
1330 rm -rf /a/opt/hub-linux-amd64*
1331 wget -P /a/opt $up
1332 tar -C /a/opt -zxf /a/opt/$uptar
1333 rm -f /a/opt/$uptar
1334 fi
1335 if ! which hub &>/dev/null; then
1336 sudo /a/opt/$updir/install
1337 fi
1338
1339 # save token across computers
1340 if [[ ! -L ~/.config/hub ]]; then
1341 if [[ -e ~/.config/hub ]]; then
1342 mv ~/.config/hub /p/c/subdir_files/.config/
1343 fi
1344 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1345 conflink
1346 fi
1347 fi
1348 command hub "$@"
1349 }
1350
1351 i() { git "$@"; }
1352 ccomp git i
1353
1354 # git status:
1355 # cvs -qn update
1356
1357 # git checkout FILE
1358 # cvs update -C FILE
1359
1360 # git pull
1361 # cvs up[date]
1362
1363 # potentially useful command translation
1364 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1365
1366 # importing cvs repo into git using git-cvs package:
1367 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1368
1369 ic() {
1370 # fast commit all
1371 git commit -am "$*"
1372 }
1373
1374 ipp() {
1375 git pull
1376 git push
1377 }
1378
1379
1380 ifn() {
1381 # insensitive find
1382 # -L = follow symlinks
1383 find -L . -not \( -name .svn -prune -o -name .git -prune \
1384 -o -name .hg -prune -o -name .editor-backups -prune \
1385 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1386 }
1387
1388 ifd() {
1389 # insensitive find directory
1390 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1391 -o -name .hg -prune -o -name .editor-backups -prune \
1392 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1393 }
1394
1395
1396 ipdrop() {
1397 sudo iptables -A INPUT -s $1 -j DROP
1398 }
1399
1400
1401 istext() {
1402 grep -Il "" "$@" &>/dev/null
1403 }
1404
1405 pst() {
1406 pstree -apnA
1407 }
1408
1409 jtail() {
1410 journalctl -n 10000 -f "$@"
1411 }
1412 jr() { journalctl "$@" ; }
1413 jrf() { journalctl -f "$@" ; }
1414 jru() {
1415 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1416 }
1417
1418
1419
1420 l() {
1421 if [[ $PWD == /[iap] ]]; then
1422 command ls -A --color=auto -I lost+found "$@"
1423 else
1424 command ls -A --color=auto "$@"
1425 fi
1426 }
1427
1428 lcn() { locate -i "*$**"; }
1429
1430 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1431
1432 lt() { ll -tr "$@"; }
1433
1434 lld() { ll -d "$@"; }
1435
1436 ccomp ls l lg lt lld ll
1437
1438 # low recursively
1439 lowr() {
1440 local f dirs i a
1441 local -a all
1442 for dirs in false true; do
1443 for f; do
1444 if [[ -d $f ]]; then
1445 all=("$f"/**)
1446 # reverse the order to rename the nested dirs first.
1447 # note: 0 element is the dir itself
1448 for ((i=${#all[@]}-1; i>=1; i--)); do
1449 a="${all[i]}"
1450 if $dirs && [[ -d $a ]]; then
1451 # e dirs low "$a" # debug
1452 low "$a"
1453 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1454 # debug
1455 # e not dirs low "$a" # debug
1456 low "$a"
1457 fi
1458 done
1459 fi
1460 # just rename all the top level args on the second pass
1461 if $dirs; then
1462 # e final dirs low "$f" # debug
1463 low "$f"
1464 fi
1465 done
1466 done
1467 }
1468
1469 low() { # make filenames lowercase, remove bad chars
1470 local arg new dir f
1471 for arg; do
1472 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1473 dir="${arg%/*}"
1474 if (( ${#dir} == ${#arg} )); then
1475 dir=.
1476 fi
1477 f="${arg##*/}"
1478 new="${f,,}" # downcase
1479 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1480 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1481 new="${new%"${new##*[[:alnum:]]}"}"
1482 # remove bad underscores, like __ and _._
1483 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1484 safe_rename "$dir/$f" "$dir/$new" || return 1
1485 done
1486 return 0
1487 }
1488
1489 lower() { # make first letter of filenames lowercase.
1490 local x
1491 for x in "$@"; do
1492 if [[ ${x::1} == [A-Z] ]]; then
1493 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1494 safe_rename "$x" "$y" || return 1
1495 fi
1496 done
1497 }
1498
1499
1500 k() { # history search
1501 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1502 }
1503 ks() { # history search with context
1504 # args are an extended regex used by sed
1505 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1506 }
1507 ksu() { # history search unique
1508 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1509 }
1510
1511 # todo: id like to do maybe a daily or hourly cronjob to
1512 # check that my history file size is increasing. Ive had it
1513 # inexplicably truncated in the past.
1514 histrm() {
1515 history -n
1516 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1517 read -p "press anything but contrl-c to delete"
1518 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1519 history -d $entry
1520 done
1521 history -w
1522 }
1523
1524 ccomp grep k ks ksu histrm
1525
1526
1527 make-targets() {
1528 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1529 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1530 }
1531
1532 mkc() {
1533 mkdir "$1"
1534 c "$1"
1535 }
1536 ccomp mkdir mkc
1537
1538 mkct() {
1539 mkc $(mktemp -d)
1540 }
1541
1542 mkt() { # mkdir and touch file
1543 local path="$1"
1544 mkdir -p "$(dirname "$path")"
1545 touch "$path"
1546 }
1547
1548 # shellcheck disable=SC2032
1549 mkdir() { command mkdir -p "$@"; }
1550
1551 nags() {
1552 # https://github.com/HenriWahl/Nagstamon/issues/357
1553 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1554 /usr/lib/notification-daemon/notification-daemon &
1555 fi
1556 /usr/bin/nagstamon &
1557 }
1558
1559 nmt() {
1560 # cant use s because sudo -i doesnt work for passwordless sudo command
1561 case $EUID in
1562 0)
1563 sudo nmtui-connect "$@"
1564 ;;
1565 *)
1566 nmtui-connect "$@"
1567 ;;
1568 esac
1569 }
1570
1571
1572 ngset() {
1573 if shopt nullglob >/dev/null; then
1574 ngreset=false
1575 else
1576 shopt -s nullglob
1577 ngreset=true
1578 fi
1579 }
1580 ngreset() {
1581 if $ngreset; then
1582 shopt -u nullglob
1583 fi
1584 }
1585
1586 nopanic() {
1587 # shellcheck disable=SC2024
1588 ngset
1589 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1590 base=${f##*/}
1591 if [[ -s $f ]]; then
1592 echo ================== $f =============
1593 s tee -a /var/log/exim4/$base-archive <$f
1594 s truncate -s0 $f
1595 fi
1596 done
1597 ngreset
1598 }
1599
1600
1601 ping() { command ping -O "$@"; }
1602 p8() { ping "$@" 8.8.8.8; }
1603 p6() { ping6 "$@" 2001:4860:4860::8888; }
1604
1605 pkx() { # package extract
1606 local pkg cached tmp f
1607 c $(mktemp -d)
1608 pkg=$1
1609 # shellcheck disable=SC2012
1610 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1611 if [[ $cached ]]; then
1612 cp $cached .
1613 else
1614 aptitude download $pkg || return 1
1615 fi
1616 tmp=(*); f=${tmp[0]} # only 1 expected
1617 ex $f
1618 rm -f $f
1619 }
1620
1621 # pgrep and kill
1622 pk1() {
1623 local pid
1624 pid=($(pgrep -f "$*"))
1625 case ${#pid[@]} in
1626 1)
1627 # shellcheck disable=SC2128
1628 {
1629 ps -F $pid
1630 m kill $pid
1631 }
1632 ;;
1633 0) echo "no pid found" ;;
1634 *)
1635 ps -F ${pid[@]}
1636 ;;
1637 esac
1638 }
1639
1640 psg () {
1641 local x y help
1642 help="Usage: psg [--help] GREP_ARGS
1643 grep ps and output in a nice format"
1644 if [[ $1 == --help ]]; then
1645 echo "$help"
1646 return
1647 fi
1648 x=$(ps -eF)
1649 # final grep is because some commands tend to have a lot of trailing spaces
1650 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1651 if [[ $y ]]; then
1652 echo "$x" | head -n 1 || [[ $? == 141 ]]
1653 echo "$y"
1654 fi
1655 }
1656
1657 pubip() { curl -4s https://icanhazip.com; }
1658 pubip6() { curl -6s https://icanhazip.com; }
1659 whatismyip() { pubip; }
1660
1661
1662 q() { # start / launch a program in the backround and redir output to null
1663 "$@" &> /dev/null &
1664 }
1665
1666 # shellcheck disable=SC2120
1667 r() {
1668 if [[ $HISTFILE ]]; then
1669 history -a # save history
1670 fi
1671 trap ERR # this avoids a segfault
1672 exit ${1:0}
1673 # i had this redir, not sure why
1674 # exit "$@" 2>/dev/null
1675 }
1676
1677 # scp is insecure and deprecated.
1678 scp() {
1679 rsync --inplace "$@"
1680 }
1681 ccomp rsync scp
1682
1683 randport() {
1684 # available high ports are 1024-65535,
1685 # but lets skip things that are more likely to be in use
1686 python3 <<'EOF'
1687 import secrets
1688 print(secrets.SystemRandom().randrange(10002,65500))
1689 EOF
1690 }
1691
1692 # reapply bashrc
1693 reb() {
1694 source ~/.bashrc
1695 }
1696
1697 rl() {
1698 readlink -f "$@"
1699 }
1700 ccomp readlink rl
1701
1702 rsd() {
1703 # rsync, root is required to keep permissions right.
1704 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1705 # --no-times --delete
1706 # basically, make an exact copy, use checksums instead of file times to be more accurate
1707 rsync -ahvic --delete "$@"
1708 }
1709 rsa() {
1710 # like rlu, but dont delete files on the target end which
1711 # do not exist on the original end.
1712 rsync -ahvic "$@"
1713 }
1714 rst() {
1715 # rl without preserving modification time.
1716 rsync -ahvic --delete --no-t "$@"
1717 }
1718 # [RSYNC_OPTS] HOST PATH
1719 rsu() {
1720 # eg. rsu -opts frodo /testpath
1721 # relative paths will expanded with readlink -f.
1722 opts=("${@:1:$#-2}") # 1 to last -2
1723 path="${*:$#}" # last
1724 host="${*:$#-1:1}" # last -1
1725 if [[ $path == .* ]]; then
1726 path=$(readlink -f $path)
1727 fi
1728 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1729 }
1730 ccomp rsync rsd rsa rst rsu
1731
1732 # find programs listening on a port
1733 ssp() {
1734 local port=$1
1735 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1736 s ss -lpn state listening sport = $port
1737 }
1738
1739 resolvcat() {
1740 local f
1741 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1742 m s nscd -i hosts
1743 fi
1744 f=/etc/resolv.conf
1745 echo $f:; ccat $f
1746 hr; s ss -lpn sport = 53
1747 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1748 # this will fail is dnsmasq is failed
1749 hr; m ser status dnsmasq | cat || :
1750 f=/etc/dnsmasq.conf
1751 hr; echo $f:; ccat $f
1752 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1753 f=/etc/dnsmasq-servers.conf
1754 hr; echo $f:; ccat $f
1755 fi
1756 hr
1757 echo /etc/nsswitch.conf:
1758 grep '^ *hosts:' /etc/nsswitch.conf
1759 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1760 hr; m ser status systemd-resolved | cat || :
1761 hr; m resolvectl status | cat
1762 fi
1763
1764 }
1765 rcat() {
1766 resolvcat | less
1767 }
1768 reresolv() {
1769 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1770 m ser stop nscd
1771 sleep .5
1772 m ser start nscd
1773 m sudo nscd -i hosts
1774 fi
1775 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1776 m sudo systemctl restart dnsmasq
1777 fi
1778 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1779 m sudo systemctl restart systemd-resolved
1780 fi
1781 if type -P resolvectl &>/dev/null; then
1782 resolvectl flush-caches
1783 fi
1784 }
1785
1786 rmstrips() {
1787 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1788 }
1789
1790 urun () {
1791 umask $1
1792 shift
1793 "$@"
1794 }
1795 sudo () {
1796 command sudo "$@" || return $?
1797 DID_SUDO=true
1798 }
1799 s() {
1800 # background
1801 # I use a function because otherwise we cant use in a script,
1802 # cant assign to variable.
1803 #
1804 # note: gksudo is recommended for X apps because it does not set the
1805 # home directory to the same, and thus apps writing to ~ fuck things up
1806 # with root owned files.
1807 #
1808 if [[ $EUID != 0 || $1 == -* ]]; then
1809 # shellcheck disable=SC2034
1810 SUDOD="$PWD" command sudo -i "$@"
1811 DID_SUDO=true
1812 else
1813 "$@"
1814 fi
1815 }
1816 sb() { # sudo bash -c
1817 # use sb instead of s is for sudo redirections,
1818 # eg. sb 'echo "ok fine" > /etc/file'
1819 # shellcheck disable=SC2034
1820 local SUDOD="$PWD"
1821 sudo -i bash -c "$@"
1822 }
1823 # secret sudo
1824 se() { s urun 0077 "$@"; }
1825 ccomp sudo s sb se
1826
1827 safe_rename() { # warn and dont rename if file exists.
1828 # mv -n exists, but it\'s silent
1829 if [[ $# != 2 ]]; then
1830 echo safe_rename error: $# args, need 2 >2
1831 return 1
1832 fi
1833 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
1834 if [[ -e $2 || -L $2 ]]; then
1835 echo "Cannot rename $1 to $2 as it already exists."
1836 else
1837 mv -vi "$1" "$2"
1838 fi
1839 fi
1840 }
1841
1842
1843 sd() {
1844 sudo dd status=none of="$1"
1845 }
1846
1847 ser() {
1848 if type -p systemctl &>/dev/null; then
1849 s systemctl "$@"
1850 else
1851 if (( $# >= 3 )); then
1852 echo iank: ser expected 2 or less arguments
1853 return 1
1854 fi
1855 s service $2 $1
1856 fi
1857 }
1858 serstat() {
1859 systemctl -n 40 status "$@"
1860 }
1861
1862 seru() { systemctl --user "$@"; }
1863 # like restart, but do nothing if its not already started
1864 srestart() {
1865 local service=$1
1866 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
1867 systemctl restart $service
1868 fi
1869 }
1870
1871 setini() { # set a value in a .ini style file
1872 key="$1" value="$2" section="$3" file="$4"
1873 if [[ -s $file ]]; then
1874 sed -ri -f - "$file" <<EOF
1875 # remove existing keys
1876 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
1877 # add key
1878 /^\s*\[$section\]/a $key=$value
1879 # from section to eof, do nothing
1880 /^\s*\[$section\]/,\$b
1881 # on the last line, if we haven't found section yet, add section and key
1882 \$a [$section]\\
1883 $key=$value
1884 EOF
1885 else
1886 cat >"$file" <<EOF
1887 [$section]
1888 $key=$value
1889 EOF
1890 fi
1891 }
1892
1893 sgo() { # service go
1894 service=$1
1895 ser restart $service || return 1
1896 if type -p systemctl &>/dev/null; then
1897 ser enable $service
1898 fi
1899 }
1900 soff () {
1901 for service; do
1902 # ignore services that dont exist
1903 if systemctl cat $service &>/dev/null; then
1904 ser stop $service;
1905 ser disable $service
1906 fi
1907 done
1908 }
1909
1910 sgu() {
1911 systemctl list-unit-files | rg "$@"
1912 }
1913
1914
1915 sk() {
1916
1917
1918 # disable a warning with:
1919 # shellcheck disable=SC2206 # reasoning
1920
1921 # see bash-template/style-guide.md for justifications
1922
1923 local quotes others
1924 quotes=2048,2068,2086,2206
1925 others=2029,2033,2054,2164
1926 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
1927 }
1928
1929
1930 # sl: ssh, but firsh rsync our bashrc and related files to a special
1931 # directory on the remote host if needed.
1932
1933 # Some environment variables and files need to be setup for this to work
1934 # (mine are set at the beginning of this file)
1935
1936 # SL_FILES_DIR: Environment variable. Path to folder which should at
1937 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
1938 # remote hosts (top level symlinks are resolved) unless the host already
1939 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
1940 # control and sync files to separately and already has the ~/.bashrc you
1941 # want. The remote bash will also take its .inputrc config from this
1942 # folder (default of not existing is fine). Mine looks like this:
1943 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
1944
1945 # SL_INFO_DIR: Environment variable. This folder stores info about what
1946 # we detected on the remote system and when we last synced. It will be created
1947 # if it does not exist. Sometimes you may want to forget about a
1948 # remote system, you can use sl --rsync, or the function for that slr
1949 # below.
1950
1951 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
1952 # depending on the remote host. Run this string on the remote host the
1953 # first time sl is run (or if we run slr). The result is passed to
1954 # SL_TEST_HOOK. For example,
1955 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
1956
1957 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
1958 # $SL_FILES_DIR to vary the files synced.
1959
1960 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
1961 # example to exclude files within a directory. Note, excluded
1962 # files wont be deleted on rsync, you can add --delete-excluded
1963 # to the rsync command if that is desired.
1964
1965 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
1966
1967 # For when ~/.bashrc is already customized on the remote server, you
1968 # might find it problematic that ~/.bashrc is sourced for ALL ssh
1969 # commands, even in scripts. This paragraph is all about that. bash
1970 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
1971 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
1972 # and if you customize it, probably has bugs from time to time. This is
1973 # bad. Here's how I fix it. I have a special condition to "return" in my
1974 # .bashrc for noninteractive ssh shells (copy that code). Then use this
1975 # function or similar that passes LC_USEBASHRC=t when sshing and I want
1976 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
1977 # separate file because even if I return early on, the whole file gets
1978 # parsed which can fail if there is a syntax error.
1979 sl() {
1980 # Background on LC_USEBASHRC var (no need to read if you just want to
1981 # use this function): env variables sent across ssh are strictly
1982 # limited, but we get LC_* at least in debian based machines, so we
1983 # just make that * be something no normal program would use. Note, on
1984 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
1985 # set, and the inner shell also allows running a nondefault
1986 # .bashrc. This means the outer shell still ran the default .bashrc,
1987 # but that is the best we can do.
1988
1989 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
1990 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
1991 declare -a args tmpa
1992
1993 args=($SL_SSH_ARGS)
1994
1995 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
1996 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
1997 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
1998 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
1999 # [command]
2000
2001 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
2002 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
2003 # [-F configfile] [-I pkcs11] [-i identity_file]
2004 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
2005 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
2006 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
2007
2008 force_rsync=false
2009 if [[ $1 == --rsync ]]; then
2010 force_rsync=true
2011 shift
2012 fi
2013
2014 sl_test_cmd=$SL_TEST_CMD
2015 sl_test_hook=$SL_TEST_HOOK
2016 sl_rsync_args=$SL_RSYNC_ARGS
2017 while [[ $1 ]]; do
2018 case "$1" in
2019 --rsync)
2020 force_rsync=true
2021 ;;
2022 --sl-test-cmd)
2023 sl_test_cmd="$2"
2024 shift
2025 ;;
2026 --sl-test-hook)
2027 sl_test_hook="$2"
2028 shift
2029 ;;
2030 --sl-rsync-args)
2031 sl_rsync_args="$2"
2032 shift
2033 ;;
2034 *)
2035 break
2036 ;;
2037 esac
2038 shift
2039 done
2040
2041 while [[ $1 ]]; do
2042 case "$1" in
2043 # note we dont support things like -4oOption
2044 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2045 args+=("$1"); shift
2046 ;;
2047 -[bcDEeFIiJLlmOopQRSWw]*)
2048 # -oOption etc is valid
2049 if (( ${#1} >= 3 )); then
2050 args+=("$1"); shift
2051 else
2052 args+=("$1" "$2"); shift 2
2053 fi
2054 ;;
2055 *)
2056 break
2057 ;;
2058 esac
2059 done
2060 remote="$1"
2061 if [[ ! $remote ]]; then
2062 echo $0: error hostname required >&2
2063 return 1
2064 fi
2065 shift
2066
2067 if [[ ! $SL_INFO_DIR ]]; then
2068 echo error: missing '$SL_INFO_DIR' env var >&2
2069 return 1
2070 fi
2071
2072 dorsync=false
2073 haveinfo=false
2074 tmpa=($SL_INFO_DIR/???????????"$remote")
2075 sshinfo=${tmpa[0]}
2076 if [[ -e $sshinfo ]]; then
2077 if $force_rsync; then
2078 rm -f $sshinfo
2079 else
2080 haveinfo=true
2081 fi
2082 fi
2083 if $haveinfo; then
2084 tmp=${sshinfo[0]##*/}
2085 tmp2=${tmp::11}
2086 type=${tmp2: -1}
2087 extra_info=$(cat $sshinfo)
2088 else
2089 # we test for string to know ssh succeeded
2090 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2091 testcmd="if $testbool; then printf y; else printf n; fi"
2092 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2093 echo failed sl test. doing plain ssh -v
2094 command ssh -v "${args[@]}" "$remote"
2095 fi
2096 if [[ $tmp == y* ]]; then
2097 type=a
2098 else
2099 dorsync=true
2100 type=b
2101 fi
2102 extra_info="${tmp:1}"
2103 fi
2104 if [[ $sl_test_hook ]]; then
2105 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2106 fi
2107
2108 if $haveinfo && [[ $type == b ]]; then
2109 info_sec=${tmp::10}
2110 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2111 files_sec=${files_sec%%.*}
2112 if (( files_sec > info_sec )); then
2113 dorsync=true
2114 rm -f $sshinfo
2115 fi
2116 fi
2117
2118 sync_dirname=${SL_FILES_DIR##*/}
2119
2120 if [[ ! $SL_FILES_DIR ]]; then
2121 echo error: missing '$SL_FILES_DIR' env var >&2
2122 return 1
2123 fi
2124
2125 if $dorsync; then
2126 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2127 fi
2128 if $dorsync || ! $haveinfo; then
2129 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2130 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2131 printf "%s\n" "$extra_info" >$sshinfo
2132 chmod 666 $sshinfo
2133 fi
2134 if [[ $type == b ]]; then
2135 if (( ${#@} )); then
2136 # Theres a couple ways to pass arguments, im not sure whats best,
2137 # but relying on bash 4.4+ escape quoting seems most reliable.
2138 command ssh "${args[@]}" "$remote" \
2139 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2140 elif [[ ! -t 0 ]]; then
2141 # This case is when commands are being piped to ssh.
2142 # Normally, no bashrc gets sourced.
2143 # But, since we are doing all this, lets source it because we can.
2144 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2145 else
2146 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2147 fi
2148 else
2149 if [[ -t 0 ]]; then
2150 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2151 else
2152 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2153 fi
2154 fi
2155 # this function inspired from https://github.com/Russell91/sshrc
2156 }
2157
2158 slr() {
2159 sl --rsync "$@"
2160 }
2161 sss() { # ssh solo
2162 sl -oControlMaster=no -oControlPath=/ "$@"
2163 }
2164 # kill off old shared socket then ssh
2165 ssk() {
2166 m ssh -O exit "$@" || [[ $? == 255 ]]
2167 m sl "$@"
2168 }
2169 ccomp ssh sl slr sss ssk
2170 # plain ssh
2171 ssh() {
2172 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2173 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2174 else
2175 LC_USEBASHRC=t command ssh "$@"
2176 fi
2177 }
2178
2179
2180 slog() {
2181 # log with script. timing is $1.t and script is $1.s
2182 # -l to save to ~/typescripts/
2183 # -t to add a timestamp to the filenames
2184 local logdir do_stamp arg_base
2185 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2186 logdir="/a/dt/"
2187 do_stamp=false
2188 while getopts "lt" option
2189 do
2190 case $option in
2191 l ) arg_base=$logdir ;;
2192 t ) do_stamp=true ;;
2193 esac
2194 done
2195 shift $((OPTIND - 1))
2196 arg_base+=$1
2197 [[ -e $logdir ]] || mkdir -p $logdir
2198 $do_stamp && arg_base+=$(date +%F.%T%z)
2199 script -t $arg_base.s 2> $arg_base.t
2200 }
2201 splay() { # script replay
2202 #logRoot="$HOME/typescripts/"
2203 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2204 scriptreplay "$1.t" "$1.s"
2205 }
2206
2207 sr() {
2208 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2209 if [[ $# == 0 ]]; then
2210 sudo -E bash -c -l "$(history -p '!!')"
2211 else
2212 echo this command redos last history item. no argument is accepted
2213 fi
2214 }
2215
2216 srm () {
2217 # with -ll, less secure but faster.
2218 command srm -ll "$@"
2219 }
2220
2221 srun() {
2222 scp $2 $1:/tmp
2223 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
2224 }
2225
2226
2227 swap() {
2228 local tmp
2229 tmp=$(mktemp)
2230 mv $1 $tmp
2231 mv $2 $1
2232 mv $tmp $2
2233 }
2234
2235 tclock() { # terminal clock
2236 local x
2237 clear
2238 date +%l:%_M
2239 len=60
2240 # this goes to full width
2241 #len=${1:-$((COLUMNS -7))}
2242 x=1
2243 while true; do
2244 if (( x == len )); then
2245 end=true
2246 d="$(date +%l:%_M) "
2247 else
2248 end=false
2249 d=$(date +%l:%M:%_S)
2250 fi
2251 echo -en "\r"
2252 echo -n "$d"
2253 for ((i=0; i<x; i++)); do
2254 if (( i % 6 )); then
2255 echo -n _
2256 else
2257 echo -n .
2258 fi
2259 done
2260 if $end; then
2261 echo
2262 x=1
2263 else
2264 x=$((x+1))
2265 fi
2266 sleep 5
2267 done
2268 }
2269
2270
2271 te() {
2272 # test existence / exists
2273 local ret=0
2274 for x in "$@"; do
2275 [[ -e "$x" || -L "$x" ]] || ret=1
2276 done
2277 return $ret
2278 }
2279
2280 psoff() {
2281 # normally, i would just execute these commands in the function.
2282 # however, DEBUG is not inherited, so we need to run it outside a function.
2283 # And we want to run set -x afterwards to avoid spam, so we cram everything
2284 # in here, and then it will run after this function is done.
2285 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2286 }
2287 pson() {
2288 PROMPT_COMMAND=prompt-command
2289 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2290 trap 'settitle "$BASH_COMMAND"' DEBUG
2291 fi
2292 }
2293
2294 tx() { # toggle set -x, and the prompt so it doesnt spam
2295 if [[ $- == *x* ]]; then
2296 set +x
2297 pson
2298 else
2299 psoff
2300 fi
2301 }
2302
2303 psnetns() {
2304 # show all processes in the network namespace $1.
2305 # blank entries appear to be subprocesses/threads
2306 local x netns
2307 netns=$1
2308 ps -w | head -n 1
2309 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2310 while read -r l; do
2311 x=$(ps -w --no-headers -p $l);
2312 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2313 done
2314 }
2315 nonet() {
2316 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2317 s ip netns add nonet
2318 fi
2319 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2320 }
2321
2322 m() { printf "%s\n" "$*"; "$@"; }
2323
2324 # update file. note: duplicated in mail-setup
2325 u() {
2326 local tmp tmpdir dest="$1"
2327 local base="${dest##*/}"
2328 local dir="${dest%/*}"
2329 if [[ $dir != "$base" ]]; then
2330 # dest has a directory component
2331 mkdir -p "$dir"
2332 fi
2333 ur=false # u result
2334 tmpdir=$(mktemp -d)
2335 cat >$tmpdir/"$base"
2336 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2337 if [[ $tmp ]]; then
2338 printf "%s\n" "$tmp"
2339 ur=true
2340 if [[ $dest == /etc/systemd/system/* ]]; then
2341 reload=true
2342 fi
2343 fi
2344 rm -rf $tmpdir
2345 }
2346
2347
2348 uptime() {
2349 if type -p uprecords &>/dev/null; then
2350 uprecords -B
2351 else
2352 command uptime
2353 fi
2354 }
2355
2356 virshrm() {
2357 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2358 }
2359
2360 vm-set-listen(){
2361 local t
2362 t=$(mktemp)
2363 local vm=$1
2364 local ip=$2
2365 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2366 sed -r "s/listen='[^']+/listen='$ip/"> $t
2367 sudo virsh undefine $vm
2368 sudo virsh define $t
2369 }
2370
2371
2372 vmshare() {
2373 vm-set-listen $1 0.0.0.0
2374 }
2375
2376
2377 vmunshare() {
2378 vm-set-listen $1 127.0.0.1
2379 }
2380
2381 myiwscan() {
2382 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2383 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2384 sudo iw dev wls1 scan | sed -rn "
2385 s/^\Wcapability: (.*)/\1/;Ta;h;b
2386 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2387 # padded to min width of 20
2388 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2389 "|sort -r
2390 }
2391
2392 # Run script by copying it to a temporary location first,
2393 # and changing directory, so we don't have any open
2394 # directories or files that could cause problems when
2395 # remounting.
2396 zr() {
2397 local tmp
2398 tmp=$(type -p "$1")
2399 if [[ $tmp ]]; then
2400 cd $(mktemp -d)
2401 cp -a "$tmp" .
2402 shift
2403 ./"${tmp##*/}" "$@"
2404 else
2405 "$@"
2406 fi
2407 }
2408
2409
2410 # * spark
2411 # spark 1 5 22 13 53
2412 # # => ▁▁▃▂▇
2413
2414 # The MIT License
2415 # Copyright (c) Zach Holman, https://zachholman.com
2416 # https://github.com/holman/spark
2417
2418 # As of 2022-10-28, I reviewed github forks that had several newer
2419 # commits, none had anything interesting. I did a little refactoring
2420 # mostly to fix emacs indent bug.
2421
2422 # Generates sparklines.
2423 _spark_echo()
2424 {
2425 if [ "X$1" = "X-n" ]; then
2426 shift
2427 printf "%s" "$*"
2428 else
2429 printf "%s\n" "$*"
2430 fi
2431 }
2432
2433
2434 spark()
2435 {
2436 local f tc
2437 local n numbers=
2438
2439 # find min/max values
2440 local min=0xffffffff max=0
2441
2442 for n in ${@//,/ }
2443 do
2444 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2445 # round the number but that doesn't work on OS X (bash3) nor does
2446 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2447 n=${n%.*}
2448 (( n < min )) && min=$n
2449 (( n > max )) && max=$n
2450 numbers=$numbers${numbers:+ }$n
2451 done
2452
2453 # print ticks
2454 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2455
2456 # use a high tick if data is constant
2457 (( min == max )) && ticks=(▅ ▆)
2458
2459 tc=${#ticks[@]}
2460 f=$(( ( (max-min) <<8)/( tc - 1) ))
2461 (( f < 1 )) && f=1
2462
2463 for n in $numbers
2464 do
2465 _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
2466 done
2467 _spark_echo
2468 }
2469
2470
2471 # * misc stuff
2472
2473
2474 if $use_color && type -p tput &>/dev/null; then
2475 term_bold="$(tput bold)"
2476 term_red="$(tput setaf 1)"
2477 term_green="$(tput setaf 2)"
2478 term_yellow="$(tput setaf 3)"
2479 term_purple="$(tput setaf 5)"
2480 term_nocolor="$(tput sgr0)" # no font attributes
2481
2482 # unused so far. commented for shellcheck
2483 # term_underl="$(tput smul)"
2484 # term_blue="$(tput setaf 4)"
2485 # term_cyan="$(tput setaf 6)"
2486 fi
2487 # Try to keep environment pollution down, EPA loves us.
2488 unset safe_term match_lhs use_color
2489
2490 # * prompt
2491
2492
2493 if [[ $- == *i* ]]; then
2494
2495
2496 case $HOSTNAME in
2497 bk|je|li)
2498 if [[ $EUID == 1000 ]]; then
2499 system-status _ ||:
2500 fi
2501 ;;
2502 esac
2503
2504
2505 # this needs to come before next ps1 stuff
2506 # this stuff needs bash 4, feb 2009,
2507 # old enough to no longer condition on $BASH_VERSION anymore
2508 shopt -s autocd
2509 shopt -s dirspell
2510 PS1='\w'
2511 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2512 PROMPT_DIRTRIM=2
2513 bind -m vi-command B:shell-backward-word
2514 bind -m vi-command W:shell-forward-word
2515 fi
2516
2517 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2518 unset PROMPT_DIRTRIM
2519 PS1="\h:$PS1"
2520 fi
2521
2522 # emacs terminal has problems if this runs slowly,
2523 # so I've thrown a bunch of things at the wall to speed it up.
2524 prompt-command() {
2525 local return=$? # this MUST COME FIRST
2526 local ps_char ps_color
2527 unset IFS
2528
2529 if [[ $HISTFILE ]]; then
2530 history -a # save history
2531 fi
2532
2533 case $return in
2534 0) ps_color="$term_purple"
2535 ps_char='\$'
2536 ;;
2537 *) ps_color="$term_green"
2538 ps_char="$return \\$"
2539 ;;
2540 esac
2541 if [[ ! -O . ]]; then # not owner
2542 if [[ -w . ]]; then # writable
2543 ps_color="$term_bold$term_red"
2544 else
2545 ps_color="$term_bold$term_green"
2546 fi
2547 fi
2548
2549 # faster than sourceing the file im guessing
2550 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2551 eval $(< /dev/shm/iank-status)
2552 fi
2553 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2554 ps_char="@ $ps_char"
2555 fi
2556 # We could test if sudo is active with sudo -nv
2557 # but then we get an email and log of lots of failed sudo commands.
2558 # We could turn those off, but seems better not to.
2559 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2560 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2561 fi
2562 if [[ ! $HISTFILE ]]; then
2563 ps_char="NOHIST $ps_char"
2564 fi
2565 PS1="${PS1%"${PS1#*[wW]}"} $psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2566
2567 # set titlebar. instead, using more advanced
2568 # titelbar below
2569 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2570 }
2571 PROMPT_COMMAND=prompt-command
2572
2573 if [[ $TERM == screen* ]]; then
2574 _title_escape="\033]..2;"
2575 else
2576 # somme sites recommend this, i dunno what the diff is.
2577 #_title_escape="\033]30;"
2578 _title_escape="\033]0;"
2579 fi
2580
2581 settitle () {
2582 # this makes it so we show the current command if
2583 # one is running, otherwise, show nothing
2584
2585 if [[ $1 == prompt-command ]]; then
2586 return 0
2587 fi
2588 if (( ${#BASH_ARGC[@]} == 1 && BASH_SUBSHELL == 0 )); then
2589 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2590 printf "%s" "$*"
2591 echo -ne "\007"
2592 fi
2593 }
2594
2595 # note, this wont work:
2596 # x=$(mktemp); cp a $x
2597 # I havnt figured out why, bigger fish to fry.
2598 #
2599 # for titlebar.
2600 # condition from the screen man page i think.
2601 # note: duplicated in tx()
2602 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2603 trap 'settitle "$BASH_COMMAND"' DEBUG
2604 else
2605 trap DEBUG
2606 fi
2607
2608 fi
2609
2610 # * stuff that makes sense to be at the end
2611
2612
2613 # best practice
2614 unset IFS
2615
2616 # shellcheck disable=SC1090
2617 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2618
2619 # I had this idea to start a bash shell which would run an initial
2620 # command passed through this env variable, then continue on
2621 # interactively. But the use case I had in mind went away.
2622 #
2623 # if [[ $MY_INIT_CMD ]]; then
2624 # "${MY_INIT_CMD[@]}"
2625 # unset MY_INIT_CMD
2626 # fi
2627
2628 # ensure no bad programs appending to this file will have an affect
2629 return 0